//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
#property indicator_chart_window
#property strict

extern int             LrcPeriod    = 100;            // Period for linear regression channel
extern int             LrcNo        = 150;            // Number of linear regression channels drawn
extern color           ColorUp      = clrLimeGreen;   // Color when channel sloping up
extern color           ColorDown    = clrOrangeRed;   // Color when channel sloping down
extern ENUM_LINE_STYLE ChannelStyle = STYLE_DOT;      // Channel lines style
extern string          UniqueID     = "Lrs1";         // Indicator unique ID

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()   { return(0); }
int deinit() 
{ 
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }

return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   for (int i=LrcNo-1; i>=0; i--)
   {
      string name = UniqueID+":"+(string)i;
      ObjectCreate(0,name,OBJ_REGRESSION,0,0,0);
         ObjectSet(name,OBJPROP_TIME1,Time[i]);
         ObjectSet(name,OBJPROP_TIME2,Time[i+LrcPeriod]);
         ObjectSet(name,OBJPROP_SELECTABLE,false);
         ObjectSet(name,OBJPROP_FILL,false);
         ObjectSet(name,OBJPROP_HIDDEN,true);
         ObjectSet(name,OBJPROP_STYLE,ChannelStyle);
            double slope = LinearRegressionSlope(PRICE_CLOSE,LrcPeriod,i);
            color  theColor = ColorUp;
               if (slope<0) theColor = ColorDown;
               ObjectSet(name,OBJPROP_COLOR,theColor);
	}
   return(0);
}

//---------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------
//
//
//
//
//

int    lrsperiod=EMPTY_VALUE;
double lrssumX;
double lrssumXSqr;
double lrsdivisor;
double LinearRegressionSlope(int tprice, int len,int shift)
{
   double LinearRegSlope;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrsperiod != len)
   {
      lrsperiod  = len;
      lrssumX    = lrsperiod * (lrsperiod-1) / 2;
      lrssumXSqr = lrsperiod * (lrsperiod-1) * (2 * lrsperiod - 1) / 6;
      lrsdivisor = MathPow(lrssumX,2) - lrsperiod * lrssumXSqr;
   }
   for (int i=0; i<lrsperiod && (i+shift)<Bars; i++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,tprice,shift+i);
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrsdivisor != 0 ) 
         	LinearRegSlope = (lrsperiod * SumXY - lrssumX * SumY)/lrsdivisor;
   else     LinearRegSlope = 0; 
   return  (LinearRegSlope);
}
